// SubClassEditCtrlContainer.h : Declaration of the CSubClassEditCtrlContainer

#ifndef __SUBCLASSEDITCTRLCONTAINER_H_
#define __SUBCLASSEDITCTRLCONTAINER_H_

#include "resource.h"       // main symbols
#include <atlctl.h>

#include "myWTLcontrols.h" // my new control

/////////////////////////////////////////////////////////////////////////////
// CSubClassEditCtrlContainer
class ATL_NO_VTABLE CSubClassEditCtrlContainer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISubClassEditCtrlContainer, &IID_ISubClassEditCtrlContainer, &LIBID_SUBCLASSEDEDITCONTROLLib>,
	public CComCompositeControl<CSubClassEditCtrlContainer>,
	public IPersistStreamInitImpl<CSubClassEditCtrlContainer>,
	public IOleControlImpl<CSubClassEditCtrlContainer>,
	public IOleObjectImpl<CSubClassEditCtrlContainer>,
	public IOleInPlaceActiveObjectImpl<CSubClassEditCtrlContainer>,
	public IViewObjectExImpl<CSubClassEditCtrlContainer>,
	public IOleInPlaceObjectWindowlessImpl<CSubClassEditCtrlContainer>,
	public IPersistStorageImpl<CSubClassEditCtrlContainer>,
	public ISpecifyPropertyPagesImpl<CSubClassEditCtrlContainer>,
	public IQuickActivateImpl<CSubClassEditCtrlContainer>,
	public IDataObjectImpl<CSubClassEditCtrlContainer>,
	public IProvideClassInfo2Impl<&CLSID_SubClassEditCtrlContainer, NULL, &LIBID_SUBCLASSEDEDITCONTROLLib>,
	public CComCoClass<CSubClassEditCtrlContainer, &CLSID_SubClassEditCtrlContainer>
{
public:
	CSubClassEditCtrlContainer()
	{
		m_bWindowOnly = TRUE;
		CalcExtent(m_sizeExtent);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SUBCLASSEDITCTRLCONTAINER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSubClassEditCtrlContainer)
	COM_INTERFACE_ENTRY(ISubClassEditCtrlContainer)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CSubClassEditCtrlContainer)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CSubClassEditCtrlContainer)
	CHAIN_MSG_MAP(CComCompositeControl<CSubClassEditCtrlContainer>)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

BEGIN_SINK_MAP(CSubClassEditCtrlContainer)
	//Make sure the Event Handlers have __stdcall calling convention
END_SINK_MAP()

	STDMETHOD(OnAmbientPropertyChange)(DISPID dispid)
	{
		if (dispid == DISPID_AMBIENT_BACKCOLOR)
		{
			SetBackgroundColorFromAmbient();
			FireViewChange();
		}
		return IOleControlImpl<CSubClassEditCtrlContainer>::OnAmbientPropertyChange(dispid);
	}



// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// ISubClassEditCtrlContainer
public:

	enum { IDD = IDD_SUBCLASSEDITCTRLCONTAINER };
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		m_editEnterAsTab1.AttachToDlgItem(this->m_hWnd,IDC_EDITSUBCLASSED1);
		m_editEnterAsTab2.AttachToDlgItem(this->m_hWnd,IDC_EDITSUBCLASSED2);

		// The two subclassed windows
		m_editEnterAsTab1.SetWindowText(_T("Both Tab and Enter Works"));
		m_editEnterAsTab2.SetWindowText(_T("Both Tab and Enter Works"));

		// The one not sublassed	
		::SetWindowText(GetDlgItem(IDC_EDITNOTSUBCLASSED),_T("Only Tab Works"));

		return 0;
	}
private:
	WTL::CEditEnterAsTab m_editEnterAsTab1;
	WTL::CEditEnterAsTab m_editEnterAsTab2;
};

#endif //__SUBCLASSEDITCTRLCONTAINER_H_
