#if !defined(_myWTLcontrols_h)
#define _myWTLcontrols_h

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <atlApp.h>
#include <AtlCtrls.h>


namespace WTL // this will ensure better encapsulation
{
	template <class T>
	class CEditEnterAsTabT : public CWindowImpl<CEditEnterAsTabT<T> , CEdit>
	{
	public:
		BEGIN_MSG_MAP(CEditEnterAsTabT< T >)
			MESSAGE_HANDLER(WM_CHAR, OnChar)
			MESSAGE_HANDLER(WM_KEYDOWN, OnKeyDown)
		END_MSG_MAP()

		CEditEnterAsTabT(HWND hWnd = NULL){ }


		CEditEnterAsTabT< T >& operator=(HWND hWnd)
		{
			m_hWnd = hWnd;
			return *this;
		}


		LRESULT OnChar(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
		{
			//ignore without a beep
			switch (wParam)
			{
			case '\r': //Carriage return
				return 0;
				break;
			}
			return DefWindowProc(uMsg, wParam, lParam);
		}

		LRESULT OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
		{
			switch (wParam)
			{
			case VK_RETURN:
			case VK_TAB:
				::PostMessage (m_parent, WM_NEXTDLGCTL, 0, 0L);
				return FALSE;
			}
			return DefWindowProc(uMsg, wParam, lParam);
		}

		BOOL AttachToDlgItem(HWND parent, UINT dlgID)
		{
			m_dlgItem = dlgID;
			m_parent = parent;
			m_hWnd = ::GetDlgItem(parent,dlgID);
			return SubclassWindow(m_hWnd);
		}
	private:
		UINT m_dlgItem;
		HWND m_parent;
	};

	typedef CEditEnterAsTabT<CWindow>	CEditEnterAsTab;

};

#endif //_myWTLcontrols_h

